/*
 * Copyright (C) 2002-2007 The Warp Rogue Team
 * Part of the Warp Rogue Project
 *
 * This software is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License.
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY.
 *
 * See the license.txt file for more details.
 */

/*
 * Module Name: Ui
 * Description: -
 */

#include	"ui_sym.h"
#include	"ui_color.h"
#include 	"ui_keys.h"
#include 	"ui_input.h"
#include	"ui_game.h"
#include	"ui_msg.h"
#include	"ui_cmd.h"
#include	"ui_c_bar.h"
#include	"ui_g_adv.h"
#include	"ui_info.h"
#include	"ui_misc.h"
#include	"ui_visio.h"
#include	"ui_menu.h"


#define TEXT_ROWS			37
#define TEXT_COLUMNS			100

#if !defined(MODULE_IMPORT)

#define SCREEN_MIN_Y			1
#define SCREEN_MIN_X			1
#define SCREEN_MAX_Y			(TEXT_ROWS - 2)
#define SCREEN_MAX_X			(TEXT_COLUMNS - 2)

#define SEC_SCREEN_TITLE_ROW		1
#define SEC_SCREEN_MIN_Y		3
#define SEC_SCREEN_MIN_X		1
#define SEC_SCREEN_MAX_Y		(TEXT_ROWS - 4)
#define SEC_SCREEN_MAX_X		(TEXT_COLUMNS - 2)
#define SEC_SCREEN_COMMAND_ROW		(TEXT_ROWS - 2)

#define GAME_SCREEN_MESSAGE_ROW		1
#define GAME_SCREEN_MIN_X		1
#define GAME_SCREEN_MAX_X		(TEXT_COLUMNS - 2)
#define GAME_SCREEN_MIN_Y		1
#define GAME_SCREEN_MAX_Y		(TEXT_ROWS - 2)

#endif


void		ui_init(void);
void		ui_clean_up(void);

void		render_text_centered(COLOUR, SCREEN_COORD, const char *);

void		render_text(COLOUR, const char *, ...);
void		render_text_at(COLOUR, SCREEN_COORD, SCREEN_COORD,
			const char *, ...
		);

void		render_lstring_at(COLOUR, SCREEN_COORD, SCREEN_COORD,
			const char *, int
		);

SCREEN_COORD	render_long_text(COLOUR, SCREEN_COORD, SCREEN_COORD,
			const char *, SCREEN_COORD
		);

void		render_stats_at(const CHARACTER *, SCREEN_COORD, SCREEN_COORD);

void		render_dice_roll(COLOUR, const DICE_ROLL *);

void		render_key_name(COLOUR, KEY_CODE);

void		render_secondary_screen(const char *, ...);

void		render_overlay_screen_message(const char *, ...);

void		render_overlay_screen_prompt(const char *, ...);

void		message(SCREEN_ID, const char *, ...);
void		message_flush(SCREEN_ID);

void		message_clear(SCREEN_ID);

void		command_bar_message(SCREEN_ID, const char *);

void		render_character_status(const CHARACTER *, SCREEN_COORD, bool);

void		render_inventory_object(COLOUR, const CHARACTER *,
			const OBJECT *, bool
		);

void		render_menu(MENU *, SCREEN_AREA *);

void		render_command_bar(SCREEN_ID);

void		standard_confirmation_dialogue(CONFIRMATION_DIALOGUE *,
			SCREEN_COORD, SCREEN_COORD
		);

void		show_text_file(const char *, PROGRAM_DIRECTORY,
			const char *, bool
		);

